#! /usr/bin/perl

#------------------------------------------------------------------
require "drwebdc-lib.pl";
use IO::Socket;

#------------------------------------------------------------------
       print( "\nDrWeb daemon client demo is running using ");
       if( $SOCKET_MODE == $TCP_SOCKET )
       {
           print( "TCP-socket on $HOST:$PORT" );
       }
       else
       {
           print( "UNIX-socket in $SOCKET_FILE" );
       }
       print( ".\nEdit configuration data (\"drwebdc-lib.pl\") to change settings." );
       print( "\n\nRun \"drwebdc-demo.pl FILE\" to scan file." ) if( $ARGV[0] eq '' );
       print( "\n\nWarning! This is DEMO only. Explore \"clients/drwebdc\", \"clients/qmail\"," );
       print( "\n\"clients/exim\", \"clients/postfix\" and \"clients/sendmail\" directories" );
       print( "\nof DrWeb distribution for details.\n" );
       printVersion();
       printIdString();
       printBases();
       if( $ARGV[0] ne '' )
       {
          my $result = scanFile( $ARGV[0] );
          closeSocket();
          printf( "scanFile() return %u\n", $result );
       }
       exit;
#------------------------------------------------------------------
sub scanFile
{
   my $szFile = $_[0];
   my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size) = stat( $szFile );

   print( "\nscanFile() demo:\n" );

   return $DRWEBD_SOCKET_ERR if( !createSocket() );
   return $DRWEBD_SWRITE_ERR if( !writeInt( $DRWEBD_SCAN_CMD )
                                 ||
                                 !writeInt( $scanOptions )
                                 ||
                                 !writeInt( length($szFile) )
                                 ||
                                 !writeBuf( $szFile )
                                 ||
                                 !writeInt( $size ) );

   open( FH, $szFile ) || return $DRWEBD_IN_FILE;
   while( sysread( FH, $buf, 16 * 1024 ) )
   {
     if( !writeBuf( $buf ) )
     {
         close( FH );
         return $DRWEBD_SWRITE_ERR;
     }
   }
   close( FH );
   my $ret = 0;
   my $err = $sock -> recv( $ret, 4 );
   return $err > 0 ? $err : unpack( N, $ret );
}

#---------------------------------------------------------------------------
sub printVersion
{
   print( "\nprintVersion() demo:\n" );
   if( createSocket() )
   {
     if( writeInt( $DRWEBD_VERSION_CMD ) )
     {
       my $ver = recvInt();
       printf( "Daemon version: %d.%d\n", $ver / 100, $ver % 100 );
     }
     closeSocket();
  }
}

#------------------------------------------------------------------
sub printIdString
{
   print( "\nprintIdString() demo:\n" );
   if( createSocket() )
   {
     if( writeInt( $DRWEBD_IDSTRING_CMD ) )
     {
       my $ids = recvString();
       print( "ID string: \"$ids\"\n" );
     }
     closeSocket();
   }
}

#------------------------------------------------------------------
sub printBases
{
   print( "\nprintBases() demo:\n" );
   if( createSocket() )
   {
     if( writeInt( $DRWEBD_BASEINFO_CMD ) )
     {
       my $bsz = recvInt();
       print( "Virus bases loaded:\n" );
       while( $bsz )
       {
         my $bs = recvString(), $bn = recvInt();
         print( "$bs ($bn records)\n" );
         $bsz--;
       }
     }
     closeSocket();
   }
}

#------------------------------------------------------------------

