#! /usr/bin/perl

#------------------------------------------------------------------
# error codes:
$DRWEBD_DEMO_USAGE = -1;
$DRWEBD_IN_FILE = -2;
$DRWEBD_NO_MEMORY = -3;
$DRWEBD_SOCKET_ERR = -4;
$DRWEBD_SWRITE_ERR = -5;
$DRWEBD_SREAD_ERR = -6;
$DRWEBD_TIMEOUT = -7;

# daemon commands:
$DRWEBD_SCAN_CMD = 1;
$DRWEBD_VERSION_CMD = 2;
$DRWEBD_BASEINFO_CMD = 3;
$DRWEBD_IDSTRING_CMD = 4;

# scan options:
$DRWEBD_RETURN_VIRUSES = 1;
$DRWEBD_RETURN_REPORT = 2;
$DRWEBD_RETURN_CODES = 4;
$DRWEBD_HEURISTIC_ON = 8;
$scanOptions = 0;
#$scanOptions = $DRWEBD_RETURN_REPORT + $DRWEBD_RETURN_VIRUSES;

$TCP_SOCKET = 0;
$UNIX_SOCKET = 1;
$SOCKET_MODE = $TCP_SOCKET;

$HOST = "localhost";
$PORT = 3000;
$SOCKET_FILE = "/var/run/drwebd";
$sock = 0;
$TIMEOUT = 40;

#------------------------------------------------------------------
sub closeSocket
{
    $sock -> close() if( $sock );
}

#------------------------------------------------------------------
sub createTcpSocket
{
   $sock = IO::Socket::INET -> new ( PeerAddr => $_[0],
                                     PeerPort => $_[1],
                                     Proto    => "tcp",
                                     Timeout => $TIMEOUT );
   print( "Can't create TCP socket( $_[0]:$_[1] )\n" ) if !$sock;
   return $sock;
}

#------------------------------------------------------------------
sub createUnixSocket
{
   $sock = IO::Socket::INET -> new ( Peer => $_[0] );
   print( "Can't create Unix socket( $_[0] )\n" ) if !$sock;
   return $sock;
}

#------------------------------------------------------------------
sub writeInt
{
  my $i = pack( N, $_[0] );
  return $sock -> send( $i );
}

#------------------------------------------------------------------
sub writeBuf
{
  return $sock -> send( $_[0] );
}

#------------------------------------------------------------------
sub recvInt
{
    my $w = 0;
    $sock -> recv( $w, 4 );
    return unpack( N, $w );
}

#------------------------------------------------------------------
sub recvString
{
   my $ids = '';
   $sock -> recv( $ids, recvInt() );
   return $ids;
}

#------------------------------------------------------------------
sub createSocket
{
  return createTcpSocket( $HOST, $PORT )
         if( $SOCKET_MODE == $TCP_SOCKET );
  return createUnixSocket( $SOCKET_FILE );
}

#------------------------------------------------------------------
1;
