#ifndef __DWC_TIMO_H
#define __DWC_TIMO_H

#include "dwc_type.h"

typedef struct _DWC_timer_t*    DWC_timer_hnd_t;

#define INVALID_TIMER           ((DWC_timer_hnd_t)0)
#define INFINITE_TIMER          ((DWC_timer_hnd_t)1)
#define INFINITE_TIMEOUT        ((DWC_timeout_t)(0))
#define INVALID_TIMEOUT         ((DWC_timeout_t)(~0))

typedef void (*DWC_TimeoutProc_t)(DWC_pointer_t);

extern DWC_error_code_t     InitTimerEngine ( void );
extern DWC_error_code_t     DeInitTimerEngine ( void );
extern DWC_timer_hnd_t      SetTimeout ( DWC_timeout_t timeout, DWC_TimeoutProc_t Proc, DWC_pointer_t Data, DWC_bool_t DelAtAlarm );
extern DWC_bool_t           ExpiredTimeout( DWC_timer_hnd_t Timer );
extern DWC_timeout_t        RetrieveTimeout( DWC_timer_hnd_t Timer );
extern DWC_bool_t           AlarmTimeout( DWC_timer_hnd_t Timer );
extern DWC_bool_t           ClearTimeout( DWC_timer_hnd_t Timer );

#endif
