#ifndef _DWC_TYPE_H
#define _DWC_TYPE_H

#if defined(__WIN32_DW)
#include <stdio.h>
#endif
#include <sys/types.h>

#define DWC_IPC_WAIT_RECV   (1<<1)
#define DWC_IPC_WAIT_SEND   (1<<2)
#define DWC_IPC_WAIT_EXCP   (1<<3)
    
typedef enum {
    DWC_IPC_TYPE_0 = 0,
    DWC_IPC_TCP_SOCKET,
    DWC_IPC_UNIX_SOCKET,
    DWC_IPC_TYPE_MAX
}                   DWC_ipc_type_t;
typedef enum {
    DWC_IPC_SIDE_0 = 0,
    DWC_IPC_SIDE_LOCAL,
    DWC_IPC_SIDE_REMOTE,
    DWC_IPC_SIDE_MAX
}                   DWC_side_t;
typedef enum {
    DWC_IPC_CMD_0 = 0,
    DWC_IPC_CMD_SETPORT,
    DWC_IPC_CMD_SETADDR,
    DWC_IPC_CMD_SETALL,
    DWC_IPC_CMD_RESOLVE,
    DWC_IPC_CMD_BIND,
    DWC_IPC_CMD_MAX
}                   DWC_cmd_t;
typedef int         DWC_error_code_t;
typedef size_t      DWC_length_t;
typedef int         DWC_timeout_t;
typedef char        DWC_char_t;
typedef void*       DWC_pointer_t;
typedef char*       DWC_string_t;
typedef unsigned int DWC_socklen_t; /* ASV: the best way - use autoconf */
#if defined(__cplusplus)
typedef bool        DWC_bool_t;
#ifndef FALSE
#define FALSE       (0)
#endif
#ifndef TRUE
#define TRUE        (1)
#endif
#else /* ANSI C */
#ifndef FALSE
typedef enum {
    FALSE = 0,
    TRUE = !FALSE
}                   DWC_bool_t;
#else
typedef int         DWC_bool_t;
#endif /* __WIN32_DW */
#endif

typedef struct {
    DWC_length_t    max_len; /* IN: max length of log-buffer */
    DWC_length_t    cur_len; /* IN/OUT: current length of buffer for log-buffer */
    DWC_string_t    line;    /* IN: ptr to log-buffer */
} DWC_log_t;

#endif /* _DWC_TYPE_H */
